=== modified file 'drizzled/common.h'
--- drizzled/common.h	2010-03-01 01:31:21 +0000
+++ drizzled/common.h	2010-03-02 07:09:16 +0000
@@ -55,7 +55,6 @@
 #define SELECT_NO_JOIN_CACHE    (UINT64_C(1) << 7)     // intern
 #define OPTION_BIG_TABLES       (UINT64_C(1) << 8)     // THD, user
 #define OPTION_BIG_SELECTS      (UINT64_C(1) << 9)     // THD, user
-#define OPTION_LOG_OFF          (UINT64_C(1) << 10)    // THD, user
 #define TMP_TABLE_ALL_COLUMNS   (UINT64_C(1) << 12)    // SELECT, intern
 #define OPTION_WARNINGS         (UINT64_C(1) << 13)    // THD, user
 #define OPTION_AUTO_IS_NULL     (UINT64_C(1) << 14)    // THD, user, binlog
@@ -74,18 +73,10 @@
    key checks in some cases */
 #define OPTION_RELAXED_UNIQUE_CHECKS    (UINT64_C(1) << 27) // THD, user, binlog
 #define SELECT_NO_UNLOCK                (UINT64_C(1) << 28) // SELECT, intern
-#define OPTION_SCHEMA_TABLE             (UINT64_C(1) << 29) // SELECT, intern
 /** Flag set if setup_tables already done */
 #define OPTION_SETUP_TABLES_DONE        (UINT64_C(1) << 30) // intern
 /** If not set then the thread will ignore all warnings with level notes. */
 #define OPTION_SQL_NOTES                (UINT64_C(1) << 31) // THD, user
-#define OPTION_PROFILING                (UINT64_C(1) << 33)
-
-/*
-  Dont report errors for individual rows,
-  But just report error on commit (or read ofcourse)
-*/
-#define OPTION_ALLOW_BATCH              (UINT64_C(1) << 33) // THD, intern (slave)
 
 /**
   Maximum length of time zone name that we support
@@ -104,13 +95,6 @@
 #define SQLSTATE_LENGTH 5
 
 /*
-  Maximum length of comments
-*/
-#define TABLE_COMMENT_MAXLEN 2048
-#define COLUMN_COMMENT_MAXLEN 1024
-#define INDEX_COMMENT_MAXLEN 1024
-
-/*
   USER_HOST_BUFF_SIZE -- length of string buffer, that is enough to contain
   username and hostname parts of the user identifier with trailing zero in
   MySQL standard format:
@@ -118,8 +102,6 @@
 */
 #define USER_HOST_BUFF_SIZE HOSTNAME_LENGTH + USERNAME_LENGTH + 2
 
-#define LOCAL_HOST	"localhost"
-
 /*
   You should add new commands to the end of this list, otherwise old
   servers won't be able to handle them as 'unsupported'.
@@ -144,54 +126,21 @@
 #define ENUM_FLAG	256		/* field is an enum */
 #define AUTO_INCREMENT_FLAG 512		/* field is a autoincrement field */
 #define TIMESTAMP_FLAG	1024		/* Field is a timestamp */
-#define SET_FLAG	2048		/* field is a set */
 #define NO_DEFAULT_VALUE_FLAG 4096	/* Field doesn't have default value */
 #define ON_UPDATE_NOW_FLAG 8192         /* Field is set to NOW on UPDATE */
-#define NUM_FLAG	32768		/* Field is num (for clients) */
 #define PART_KEY_FLAG	16384		/* Intern; Part of some key */
 #define GROUP_FLAG	32768		/* Intern: Group field */
 #define UNIQUE_FLAG	65536		/* Intern: Used by sql_yacc */
 #define BINCMP_FLAG	131072		/* Intern: Used by sql_yacc */
-#define GET_FIXED_FIELDS_FLAG (1 << 18) /* Used to get fields in item tree */
-#define FIELD_IN_PART_FUNC_FLAG (1 << 19)/* Field part of partition func */
-#define FIELD_IN_ADD_INDEX (1<< 20)	/* Intern: Field used in ADD INDEX */
-#define FIELD_IS_RENAMED (1<< 21)       /* Intern: Field is being renamed */
-#define FIELD_STORAGE_FLAGS 22          /* Storage type: bit 22, 23 and 24 */
 #define COLUMN_FORMAT_FLAGS 25          /* Column format: bit 25, 26 and 27 */
 #define COLUMN_FORMAT_MASK 7
 
-#define REFRESH_LOG		2	/* Start on new log file */
-#define REFRESH_TABLES		4	/* close all tables */
-#define REFRESH_STATUS		16	/* Flush status variables */
-
-/* The following can't be set with mysql_refresh() */
-#define REFRESH_READ_LOCK	16384	/* Lock tables for read */
-#define REFRESH_FAST		32768	/* Intern flag */
-
 #define SERVER_STATUS_IN_TRANS     1	/* Transaction has started */
 #define SERVER_STATUS_AUTOCOMMIT   2	/* Server in auto_commit mode */
 #define SERVER_MORE_RESULTS_EXISTS 8    /* Multi query - next query exists */
 #define SERVER_QUERY_NO_GOOD_INDEX_USED 16
 #define SERVER_QUERY_NO_INDEX_USED      32
-/*
-  The server was able to fulfill the clients request and opened a
-  read-only non-scrollable cursor for a query. This flag comes
-  in reply to COM_STMT_EXECUTE and COM_STMT_FETCH commands.
-*/
-#define SERVER_STATUS_CURSOR_EXISTS 64
-/*
-  This flag is sent when a read-only cursor is exhausted, in reply to
-  COM_STMT_FETCH command.
-*/
-#define SERVER_STATUS_LAST_ROW_SENT 128
 #define SERVER_STATUS_DB_DROPPED        256 /* A database was dropped */
-#define SERVER_STATUS_NO_BACKSLASH_ESCAPES 512
-/*
-  Tell clients that this query was logged to the slow query log.
-  Not yet set in the server, but interface is defined for applications
-  to use.  See WorkLog 4098.
-*/
-#define SERVER_QUERY_WAS_SLOW           1024
 
 #define DRIZZLE_ERRMSG_SIZE	512
 
@@ -199,7 +148,6 @@
 
 #define MAX_INT_WIDTH           10      /* Max width for a LONG w.o. sign */
 #define MAX_BIGINT_WIDTH        20      /* Max width for a LONGLONG */
-#define MAX_CHAR_WIDTH		255	/* Max length for a CHAR colum */
 #define MAX_BLOB_WIDTH		(uint32_t)16777216	/* Default width for blob */
 
 #define DRIZZLE_PROTOCOL_NO_MORE_DATA 0xFE
@@ -209,15 +157,6 @@
 
 #define packet_error (~(uint32_t) 0)
 
-
-/* Shutdown/kill enums and constants */
-
-/* Bits for THD::killable. */
-#define DRIZZLE_SHUTDOWN_KILLABLE_CONNECT    (unsigned char)(1 << 0)
-#define DRIZZLE_SHUTDOWN_KILLABLE_TRANS      (unsigned char)(1 << 1)
-#define DRIZZLE_SHUTDOWN_KILLABLE_LOCK_TABLE (unsigned char)(1 << 2)
-#define DRIZZLE_SHUTDOWN_KILLABLE_UPDATE     (unsigned char)(1 << 3)
-
 #if defined(__cplusplus)
 
 namespace drizzled
@@ -252,12 +191,6 @@
                         DRIZZLE_TYPE_MAX=DRIZZLE_TYPE_BLOB
 };
 
-
-  /* The following is for user defined functions */
-
-enum Item_result {STRING_RESULT=0, REAL_RESULT, INT_RESULT, ROW_RESULT,
-                  DECIMAL_RESULT};
-
 } /* namespace drizzled */
 
 #endif /* defined(__cplusplus) */

=== modified file 'drizzled/create_field.cc'
--- drizzled/create_field.cc	2010-02-04 08:14:46 +0000
+++ drizzled/create_field.cc	2010-03-02 06:45:16 +0000
@@ -87,7 +87,7 @@
       break;
   }
 
-  if (flags & (ENUM_FLAG | SET_FLAG))
+  if (flags & ENUM_FLAG)
     interval= ((Field_enum*) old_field)->typelib;
   else
     interval= 0;

=== modified file 'drizzled/field.cc'
--- drizzled/field.cc	2010-02-26 08:21:58 +0000
+++ drizzled/field.cc	2010-03-02 06:45:16 +0000
@@ -821,7 +821,7 @@
   tmp->part_of_key.reset();
   tmp->part_of_sortkey.reset();
   tmp->unireg_check= Field::NONE;
-  tmp->flags&= (NOT_NULL_FLAG | BLOB_FLAG | UNSIGNED_FLAG | BINARY_FLAG | ENUM_FLAG | SET_FLAG);
+  tmp->flags&= (NOT_NULL_FLAG | BLOB_FLAG | UNSIGNED_FLAG | BINARY_FLAG | ENUM_FLAG);
   tmp->reset_fields();
   return tmp;
 }

=== modified file 'drizzled/field.h'
--- drizzled/field.h	2010-02-26 08:21:58 +0000
+++ drizzled/field.h	2010-03-02 06:41:59 +0000
@@ -32,6 +32,7 @@
 #include "drizzled/sql_list.h"
 #include "drizzled/structs.h"
 #include "drizzled/charset_info.h"
+#include "drizzled/item_result.h"
 
 #include <string>
 #include <vector>

=== modified file 'drizzled/hybrid_type_traits.h'
--- drizzled/hybrid_type_traits.h	2010-02-04 08:14:46 +0000
+++ drizzled/hybrid_type_traits.h	2010-03-02 06:41:59 +0000
@@ -21,6 +21,7 @@
 #define DRIZZLED_HYBRID_TYPE_TRAITS_H
 
 #include "drizzled/common.h"
+#include "drizzled/item_result.h"
 
 namespace drizzled
 {

=== modified file 'drizzled/include.am'
--- drizzled/include.am	2010-03-01 16:03:21 +0000
+++ drizzled/include.am	2010-03-02 19:29:14 +0000
@@ -203,6 +203,7 @@
 			      drizzled/index_hint.h \
 			      drizzled/internal_error_handler.h \
 			      drizzled/item.h \
+			      drizzled/item_result.h \
 			      drizzled/item/basic_constant.h \
 			      drizzled/item/bin_string.h \
 			      drizzled/item/blob.h \

=== modified file 'drizzled/item.h'
--- drizzled/item.h	2010-02-16 17:15:01 +0000
+++ drizzled/item.h	2010-03-02 06:41:59 +0000
@@ -27,6 +27,7 @@
 #include <drizzled/sql_list.h>
 #include "drizzled/memory/sql_alloc.h"
 #include <drizzled/table.h>
+#include "drizzled/item_result.h"
 
 namespace drizzled
 {
@@ -47,7 +48,6 @@
 class Client;
 }
 
-
 /**
   Dummy error processor used by default by Name_resolution_context.
 

=== added file 'drizzled/item_result.h'
--- drizzled/item_result.h	1970-01-01 00:00:00 +0000
+++ drizzled/item_result.h	2010-03-02 06:41:59 +0000
@@ -0,0 +1,34 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *  Copyright (C) 2010 Stewart Smith
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef DRIZZLED_ITEM_RESULT_H
+#define DRIZZLED_ITEM_RESULT_H
+
+enum Item_result
+{
+  STRING_RESULT=0,
+  REAL_RESULT,
+  INT_RESULT,
+  ROW_RESULT,
+  DECIMAL_RESULT
+};
+
+
+#endif /* DRIZZLED_ITEM_RESULT_H */

=== modified file 'drizzled/sql_yacc.yy'
--- drizzled/sql_yacc.yy	2010-03-02 02:07:48 +0000
+++ drizzled/sql_yacc.yy	2010-03-02 19:29:14 +0000
@@ -4841,7 +4841,7 @@
 
              {
                drizzled::TableIdentifier identifier(select->getShowSchema().c_str(), $3->table.str);
-               if (plugin::StorageEngine::getTableDefinition(*session, identifier) != EEXIST)
+               if (not plugin::StorageEngine::doesTableExist(*session, identifier))
                {
                    my_error(ER_NO_SUCH_TABLE, MYF(0),
                             select->getShowSchema().c_str(), 
@@ -4883,7 +4883,7 @@
 
              {
                drizzled::TableIdentifier identifier(select->getShowSchema().c_str(), $3->table.str);
-               if (plugin::StorageEngine::getTableDefinition(*session, identifier) != EEXIST)
+               if (not plugin::StorageEngine::doesTableExist(*session, identifier))
                {
                    my_error(ER_NO_SUCH_TABLE, MYF(0),
                             select->getShowSchema().c_str(), 
@@ -5082,7 +5082,6 @@
 describe:
           describe_command table_ident
           {
-            Item_field *my_field;
             Session *session= YYSession;
             statement::Select *select;
             LEX *lex= Lex;
@@ -5103,7 +5102,7 @@
 
              {
                drizzled::TableIdentifier identifier(select->getShowSchema().c_str(), $2->table.str);
-               if (plugin::StorageEngine::getTableDefinition(*session, identifier) != EEXIST)
+               if (not plugin::StorageEngine::doesTableExist(*session, identifier))
                {
                    my_error(ER_NO_SUCH_TABLE, MYF(0),
                             select->getShowSchema().c_str(), 
@@ -5111,44 +5110,15 @@
                }
              }
 
-             if (prepare_new_schema_table(session, lex, "COLUMNS"))
-               DRIZZLE_YYABORT;
-
-             my_field= new Item_field(&session->lex->current_select->context, NULL, NULL, "COLUMN_NAME");
-             my_field->is_autogenerated_name= false;
-             my_field->set_name("Field");
-             if (session->add_item_to_list(my_field))
-               DRIZZLE_YYABORT;
-
-             my_field= new Item_field(&session->lex->current_select->context, NULL, NULL, "DATA_TYPE");
-             my_field->is_autogenerated_name= false;
-             my_field->set_name("Type");
-             if (session->add_item_to_list(my_field))
-               DRIZZLE_YYABORT;
-
-             my_field= new Item_field(&session->lex->current_select->context, NULL, NULL, "IS_NULLABLE");
-             my_field->is_autogenerated_name= false;
-             my_field->set_name("Null");
-             if (session->add_item_to_list(my_field))
-               DRIZZLE_YYABORT;
-
-             my_field= new Item_field(&session->lex->current_select->context, NULL, NULL, "COLUMN_DEFAULT");
-             my_field->is_autogenerated_name= false;
-             my_field->set_name("Default");
-             if (session->add_item_to_list(my_field))
-               DRIZZLE_YYABORT;
-
-             my_field= new Item_field(&session->lex->current_select->context, NULL, NULL, "COLUMN_DEFAULT_IS_NULL");
-             my_field->is_autogenerated_name= false;
-             my_field->set_name("Default is NULL");
-             if (session->add_item_to_list(my_field))
-               DRIZZLE_YYABORT;
-
-             my_field= new Item_field(&session->lex->current_select->context, NULL, NULL, "COLUMN_DEFAULT_UPDATE");
-             my_field->is_autogenerated_name= false;
-             my_field->set_name("On Update");
-             if (session->add_item_to_list(my_field))
-               DRIZZLE_YYABORT;
+             if (prepare_new_schema_table(session, lex, "SHOW_COLUMNS"))
+               DRIZZLE_YYABORT;
+
+             if (session->add_item_to_list( new Item_field(&session->lex->current_select->
+                                                           context,
+                                                           NULL, NULL, "*")))
+               DRIZZLE_YYABORT;
+             (session->lex->current_select->with_wild)++;
+
           }
           opt_describe_column {}
         | describe_command opt_extended_describe
@@ -5205,14 +5175,26 @@
 
 flush_option:
           table_or_tables
-          { Lex->type|= REFRESH_TABLES; }
+          {
+            statement::Flush *statement= (statement::Flush*)Lex->statement;
+            statement->setFlushTables(true);
+          }
           opt_table_list {}
         | TABLES WITH READ_SYM LOCK_SYM
-          { Lex->type|= REFRESH_TABLES | REFRESH_READ_LOCK; }
+          {
+            statement::Flush *statement= (statement::Flush*)Lex->statement;
+            statement->setFlushTablesWithReadLock(true);
+          }
         | LOGS_SYM
-          { Lex->type|= REFRESH_LOG; }
+          {
+            statement::Flush *statement= (statement::Flush*)Lex->statement;
+            statement->setFlushLog(true);
+          }
         | STATUS_SYM
-          { Lex->type|= REFRESH_STATUS; }
+          {
+            statement::Flush *statement= (statement::Flush*)Lex->statement;
+            statement->setFlushStatus(true);
+          }
         ;
 
 opt_table_list:

=== modified file 'drizzled/statement/alter_table.cc'
--- drizzled/statement/alter_table.cc	2010-03-02 01:51:00 +0000
+++ drizzled/statement/alter_table.cc	2010-03-02 17:48:24 +0000
@@ -791,7 +791,7 @@
 
         TableIdentifier identifier(new_db, new_name_buff);
 
-        if (plugin::StorageEngine::getTableDefinition(*session, identifier) == EEXIST)
+        if (plugin::StorageEngine::doesTableExist(*session, identifier))
         {
           /* Table will be closed by Session::executeCommand() */
           my_error(ER_TABLE_EXISTS_ERROR, MYF(0), new_alias);

=== modified file 'drizzled/statement/flush.cc'
--- drizzled/statement/flush.cc	2010-02-11 03:29:52 +0000
+++ drizzled/statement/flush.cc	2010-03-02 07:34:04 +0000
@@ -52,10 +52,9 @@
 bool statement::Flush::reloadCache()
 {
   bool result= false;
-  ulong options= session->lex->type;
   TableList *tables= (TableList *) session->lex->select_lex.table_list.first;
 
-  if (options & REFRESH_LOG)
+  if (flush_log)
   {
     if (plugin::StorageEngine::flushLogs(NULL))
     {
@@ -66,17 +65,16 @@
     Note that if REFRESH_READ_LOCK bit is set then REFRESH_TABLES is set too
     (see sql_yacc.yy)
   */
-  if (options & (REFRESH_TABLES | REFRESH_READ_LOCK))
+  if (flush_tables || flush_tables_with_read_lock)
   {
-    if ((options & REFRESH_READ_LOCK) && session)
+    if (session && flush_tables_with_read_lock)
     {
       if (lock_global_read_lock(session))
       {
         return true; /* Killed */
       }
-      result= session->close_cached_tables(tables, 
-                                           (options & REFRESH_FAST) ?  false : true, 
-                                           true);
+      result= session->close_cached_tables(tables, true, true);
+
       if (make_global_read_lock_block_commit(session)) /* Killed */
       {
         /* Don't leave things in a half-locked state */
@@ -86,13 +84,11 @@
     }
     else
     {
-      result= session->close_cached_tables(tables, 
-                                           (options & REFRESH_FAST) ?  false : true, 
-                                           false);
+      result= session->close_cached_tables(tables, true, false);
     }
   }
 
-  if (session && (options & REFRESH_STATUS))
+  if (session && flush_status)
   {
     session->refresh_status();
   }

=== modified file 'drizzled/statement/flush.h'
--- drizzled/statement/flush.h	2010-02-04 08:14:46 +0000
+++ drizzled/statement/flush.h	2010-03-02 07:09:16 +0000
@@ -35,12 +35,30 @@
 public:
   Flush(Session *in_session)
     :
-      Statement(in_session)
+    Statement(in_session),
+    flush_log(false),
+    flush_tables(false),
+    flush_tables_with_read_lock(false),
+    flush_status(false)
   {}
 
   bool execute();
 
 private:
+  bool flush_log;
+  bool flush_tables;
+  bool flush_tables_with_read_lock;
+  bool flush_status;
+
+public:
+  void setFlushLog(bool f) { flush_log= f; }
+  void setFlushTables(bool f) { flush_tables= f; }
+  void setFlushTablesWithReadLock(bool f) {
+    flush_tables= flush_tables_with_read_lock= f;
+  }
+  void setFlushStatus(bool f) { flush_status= f; }
+
+private:
 
   /**
    * Reload/resets privileges and the different caches.

=== modified file 'drizzled/table_proto.h'
--- drizzled/table_proto.h	2010-02-08 01:10:03 +0000
+++ drizzled/table_proto.h	2010-03-02 06:49:12 +0000
@@ -22,6 +22,14 @@
 #define DRIZZLED_TABLE_PROTO_H
 
 namespace drizzled {
+/*
+  Maximum length of comments.
+
+  These are historical limits that no longer need to apply.
+*/
+#define TABLE_COMMENT_MAXLEN 2048
+#define COLUMN_COMMENT_MAXLEN 1024
+#define INDEX_COMMENT_MAXLEN 1024
 
 int drizzle_write_proto_file(const std::string file_name,
                              message::Table *table_proto);

=== modified file 'plugin/heap/ha_heap.cc'
--- plugin/heap/ha_heap.cc	2010-03-01 22:09:13 +0000
+++ plugin/heap/ha_heap.cc	2010-03-02 19:29:14 +0000
@@ -837,7 +837,7 @@
         key_part_size= next_field_pos;
       }
 
-      if (field->flags & (ENUM_FLAG | SET_FLAG))
+      if (field->flags & ENUM_FLAG)
         seg->charset= &my_charset_bin;
       else
         seg->charset= field->charset();

=== modified file 'plugin/schema_dictionary/columns.cc'
--- plugin/schema_dictionary/columns.cc	2010-03-01 22:24:10 +0000
+++ plugin/schema_dictionary/columns.cc	2010-03-02 17:58:59 +0000
@@ -38,6 +38,12 @@
   add_field("COLUMN_DEFAULT_IS_NULL", plugin::TableFunction::BOOLEAN);
   add_field("COLUMN_DEFAULT_UPDATE");
   add_field("IS_NULLABLE", plugin::TableFunction::BOOLEAN);
+  add_field("IS_INDEXED", plugin::TableFunction::BOOLEAN);
+  add_field("IS_USED_IN_PRIMARY", plugin::TableFunction::BOOLEAN);
+  add_field("IS_UNIQUE", plugin::TableFunction::BOOLEAN);
+  add_field("IS_MULTI", plugin::TableFunction::BOOLEAN);
+  add_field("IS_FIRST_IN_MULTI", plugin::TableFunction::BOOLEAN);
+  add_field("INDEXES_FOUND_IN", plugin::TableFunction::NUMBER);
   add_field("DATA_TYPE");
 
   add_field("CHARACTER_MAXIMUM_LENGTH", plugin::TableFunction::NUMBER);
@@ -140,6 +146,52 @@
   /* IS_NULLABLE */
   push(column.constraints().is_nullable());
 
+  /* IS_INDEXED, IS_USED_IN_PRIMARY, IS_UNIQUE, IS_MULTI, IS_FIRST_IN_MULTI, INDEXES_FOUND_IN */
+  bool is_indexed= false;
+  bool is_primary= false;
+  bool is_unique= false;
+  bool is_multi= false;
+  bool is_multi_first= false;
+  int64_t indexes_found_in= 0;
+  for (int32_t x= 0; x < getTableProto().indexes_size() ; x++)
+  {
+    drizzled::message::Table::Index index=
+      getTableProto().indexes(x);
+
+    for (int32_t y= 0; y < index.index_part_size() ; y++)
+    {
+      drizzled::message::Table::Index::IndexPart index_part=
+        index.index_part(y);
+
+      if (static_cast<int32_t>(index_part.fieldnr()) == column_iterator)
+      {
+        indexes_found_in++;
+        is_indexed= true;
+
+        if (index.is_primary())
+          is_primary= true;
+
+        if (index.is_unique())
+          is_unique= true;
+
+        if (index.index_part_size() > 1)
+        {
+          is_multi= true;
+
+          if (y == 0)
+            is_multi_first= true;
+        }
+      }
+    }
+  }
+  /* ...IS_INDEXED, IS_USED_IN_PRIMARY, IS_UNIQUE, IS_MULTI, IS_FIRST_IN_MULTI, INDEXES_FOUND_IN */
+  push(is_indexed);
+  push(is_primary);
+  push(is_unique);
+  push(is_multi);
+  push(is_multi_first);
+  push(indexes_found_in);
+
   /* DATATYPE */
   pushType(column.type());
 

=== modified file 'plugin/schema_dictionary/index_parts.cc'
--- plugin/schema_dictionary/index_parts.cc	2010-02-19 01:53:48 +0000
+++ plugin/schema_dictionary/index_parts.cc	2010-03-02 17:58:59 +0000
@@ -36,6 +36,9 @@
   add_field("SEQUENCE_IN_INDEX", plugin::TableFunction::NUMBER);
   add_field("COMPARE_LENGTH", plugin::TableFunction::NUMBER);
   add_field("IS_ORDER_REVERSE", plugin::TableFunction::BOOLEAN);
+  add_field("IS_USED_IN_PRIMARY", plugin::TableFunction::BOOLEAN);
+  add_field("IS_UNIQUE", plugin::TableFunction::BOOLEAN);
+  add_field("IS_NULLABLE", plugin::TableFunction::BOOLEAN);
 }
 
 IndexPartsTool::Generator::Generator(Field **arg) :
@@ -121,4 +124,13 @@
 
   /* IS_ORDER_REVERSE */
   push(index_part.in_reverse_order());
+
+  /* IS_USED_IN_PRIMARY */
+  push(getIndex().is_primary());
+
+  /* IS_UNIQUE */
+  push(getIndex().is_unique());
+
+  /* IS_NULLABLE */
+  push(getIndex().options().null_part_key());
 }

=== modified file 'plugin/schema_dictionary/indexes.cc'
--- plugin/schema_dictionary/indexes.cc	2010-02-18 17:24:08 +0000
+++ plugin/schema_dictionary/indexes.cc	2010-03-02 17:58:59 +0000
@@ -30,7 +30,7 @@
   add_field("TABLE_SCHEMA");
   add_field("TABLE_NAME");
   add_field("INDEX_NAME");
-  add_field("IS_PRIMARY", plugin::TableFunction::BOOLEAN);
+  add_field("IS_USED_IN_PRIMARY", plugin::TableFunction::BOOLEAN);
   add_field("IS_UNIQUE", plugin::TableFunction::BOOLEAN);
   add_field("IS_NULLABLE", plugin::TableFunction::BOOLEAN);
   add_field("KEY_LENGTH", plugin::TableFunction::NUMBER);
@@ -101,7 +101,7 @@
   /* INDEX_NAME */
   push(index.name());
 
-  /* IS_PRIMARY */
+  /* IS_USED_IN_PRIMARY */
   push(index.is_primary());
 
   /* IS_UNIQUE */

=== modified file 'plugin/schema_dictionary/tests/r/data_dictionary.result'
--- plugin/schema_dictionary/tests/r/data_dictionary.result	2010-03-02 03:06:15 +0000
+++ plugin/schema_dictionary/tests/r/data_dictionary.result	2010-03-02 17:58:59 +0000
@@ -191,6 +191,15 @@
 #
 #
 #
+#
+#
+#
+#
+#
+#
+#
+#
+#
 SELECT count(*) FROM REFERENTIAL_CONSTRAINTS;
 count(*)
 #
@@ -209,6 +218,12 @@
   `COLUMN_DEFAULT_IS_NULL` varchar(5) NOT NULL DEFAULT '',
   `COLUMN_DEFAULT_UPDATE` varchar(64) NOT NULL DEFAULT '',
   `IS_NULLABLE` varchar(5) NOT NULL DEFAULT '',
+  `IS_INDEXED` varchar(5) NOT NULL DEFAULT '',
+  `IS_USED_IN_PRIMARY` varchar(5) NOT NULL DEFAULT '',
+  `IS_UNIQUE` varchar(5) NOT NULL DEFAULT '',
+  `IS_MULTI` varchar(5) NOT NULL DEFAULT '',
+  `IS_FIRST_IN_MULTI` varchar(5) NOT NULL DEFAULT '',
+  `INDEXES_FOUND_IN` bigint NOT NULL DEFAULT '0',
   `DATA_TYPE` varchar(64) NOT NULL DEFAULT '',
   `CHARACTER_MAXIMUM_LENGTH` bigint NOT NULL DEFAULT '0',
   `CHARACTER_OCTET_LENGTH` bigint NOT NULL DEFAULT '0',
@@ -223,7 +238,7 @@
   `TABLE_SCHEMA` varchar(64) NOT NULL DEFAULT '',
   `TABLE_NAME` varchar(64) NOT NULL DEFAULT '',
   `INDEX_NAME` varchar(64) NOT NULL DEFAULT '',
-  `IS_PRIMARY` varchar(5) NOT NULL DEFAULT '',
+  `IS_USED_IN_PRIMARY` varchar(5) NOT NULL DEFAULT '',
   `IS_UNIQUE` varchar(5) NOT NULL DEFAULT '',
   `IS_NULLABLE` varchar(5) NOT NULL DEFAULT '',
   `KEY_LENGTH` bigint NOT NULL DEFAULT '0',
@@ -240,7 +255,10 @@
   `COLUMN_NUMBER` bigint NOT NULL DEFAULT '0',
   `SEQUENCE_IN_INDEX` bigint NOT NULL DEFAULT '0',
   `COMPARE_LENGTH` bigint NOT NULL DEFAULT '0',
-  `IS_ORDER_REVERSE` varchar(5) NOT NULL DEFAULT ''
+  `IS_ORDER_REVERSE` varchar(5) NOT NULL DEFAULT '',
+  `IS_USED_IN_PRIMARY` varchar(5) NOT NULL DEFAULT '',
+  `IS_UNIQUE` varchar(5) NOT NULL DEFAULT '',
+  `IS_NULLABLE` varchar(5) NOT NULL DEFAULT ''
 ) ENGINE=FunctionEngine
 show create table REFERENTIAL_CONSTRAINTS ;
 Table	Create Table

=== modified file 'tests/r/alter_table.result'
--- tests/r/alter_table.result	2010-03-02 01:04:20 +0000
+++ tests/r/alter_table.result	2010-03-02 16:42:01 +0000
@@ -417,7 +417,7 @@
 Table	Unique	Key_name	Seq_in_index	Column_name
 t1	FALSE	a	1	a
 desc t1;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 a	BIGINT	TRUE		TRUE	
 b	VARCHAR	TRUE		TRUE	
 c	DECIMAL	TRUE		TRUE	
@@ -665,7 +665,7 @@
 create table t1 (mycol int not null);
 alter table t1 alter column mycol set default 0;
 desc t1;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 mycol	INTEGER	FALSE	0	FALSE	
 drop table t1;
 create TEMPORARY table t1(id int primary key auto_increment) engine=MEMORY;
@@ -843,7 +843,7 @@
 INDEX(`int_field`)
 );
 DESCRIBE t1;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 int_field	INTEGER	FALSE		FALSE	
 char_field	VARCHAR	TRUE		TRUE	
 SHOW INDEXES FROM t1;
@@ -862,16 +862,16 @@
 3	tri
 5	pet
 DESCRIBE t2;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 unsigned_int_field	INTEGER	FALSE		FALSE	
 char_field	VARCHAR	TRUE		TRUE	
 DESCRIBE t2;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 unsigned_int_field	INTEGER	FALSE		FALSE	
 char_field	VARCHAR	TRUE		TRUE	
 ALTER TABLE t2 MODIFY unsigned_int_field BIGINT NOT NULL;
 DESCRIBE t2;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 unsigned_int_field	BIGINT	FALSE		FALSE	
 char_field	VARCHAR	TRUE		TRUE	
 DROP TABLE t2;

=== modified file 'tests/r/bigint.result'
--- tests/r/bigint.result	2010-02-19 19:04:24 +0000
+++ tests/r/bigint.result	2010-03-02 16:42:01 +0000
@@ -368,11 +368,11 @@
 9223372036854775808	-9223372036854775808
 create table t1 select -9223372036854775808 bi;
 describe t1;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 bi	BIGINT	FALSE		FALSE	
 drop table t1;
 create table t1 select -9223372036854775809 bi;
 describe t1;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 bi	DECIMAL	FALSE		FALSE	
 drop table t1;

=== modified file 'tests/r/create.result'
--- tests/r/create.result	2010-02-25 23:52:42 +0000
+++ tests/r/create.result	2010-03-02 16:42:01 +0000
@@ -107,15 +107,15 @@
 create table t1(x varchar(50) );
 create table t2 select x from t1 where 1=2;
 describe t1;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 x	VARCHAR	TRUE		TRUE	
 describe t2;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 x	VARCHAR	TRUE		TRUE	
 drop table t2;
 create table t2 select now() as a , curdate() as c , 1+1 as d , 1.0 + 1 as e , 33333333333333333 + 3 as f;
 describe t2;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 a	DATETIME	TRUE		TRUE	
 c	DATE	FALSE		FALSE	
 d	INTEGER	FALSE		FALSE	
@@ -124,17 +124,17 @@
 drop table t2;
 create table t2 select CAST("2001-12-29" AS DATE) as d, CAST("2001-12-29  20:45:11" AS DATETIME) as dt;
 describe t2;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 d	DATE	TRUE		TRUE	
 dt	DATETIME	TRUE		TRUE	
 drop table t1,t2;
 create table t1 (a int);
 create table t2 (a int) select * from t1;
 describe t1;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 a	INTEGER	TRUE		TRUE	
 describe t2;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 a	INTEGER	TRUE		TRUE	
 drop table if exists t2;
 create table t2 (a int, a float) select * from t1;
@@ -418,7 +418,7 @@
 ifnull(h,cast('yet another binary data' as binary))   as h
 from t1;
 explain t2;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 a	INTEGER	TRUE		TRUE	
 b	BIGINT	FALSE		FALSE	
 c	BIGINT	FALSE		FALSE	
@@ -453,14 +453,14 @@
 create table t1(str varchar(10) default 'def',strnull varchar(10),intg int default '10',rel double default '3.14');
 insert into t1 values ('','',0,0.0);
 describe t1;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 str	VARCHAR	TRUE	def	FALSE	
 strnull	VARCHAR	TRUE	def	TRUE	
 intg	INTEGER	TRUE	10	FALSE	
 rel	DOUBLE	TRUE	3.14	FALSE	
 create table t2 select default(str) as str, default(strnull) as strnull, default(intg) as intg, default(rel) as rel from t1;
 describe t2;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 str	VARCHAR	TRUE		TRUE	
 strnull	VARCHAR	TRUE		TRUE	
 intg	INTEGER	TRUE		TRUE	
@@ -468,12 +468,12 @@
 drop table t1, t2;
 create table t1(name varchar(10), age int default -1);
 describe t1;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 name	VARCHAR	TRUE		TRUE	
 age	INTEGER	TRUE	-1	FALSE	
 create table t2(name varchar(10), age int default - 1);
 describe t2;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 name	VARCHAR	TRUE		TRUE	
 age	INTEGER	TRUE	-1	FALSE	
 drop table t1, t2;
@@ -522,7 +522,7 @@
 CREATE TABLE t1 (f1 VARCHAR(255));
 CREATE TABLE t2 AS SELECT LEFT(f1,171) AS f2 FROM t1 UNION SELECT LEFT(f1,171) AS f2 FROM t1;
 DESC t2;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 f2	VARCHAR	TRUE		TRUE	
 DROP TABLE t1,t2;
 CREATE TABLE t12913 (f1 ENUM ('a','b')) AS SELECT 'a' AS f1;

=== modified file 'tests/r/data_dictionary_like_info.result'
--- tests/r/data_dictionary_like_info.result	2010-03-02 03:06:15 +0000
+++ tests/r/data_dictionary_like_info.result	2010-03-02 17:58:59 +0000
@@ -42,8 +42,8 @@
 a	INTEGER	TRUE		TRUE	
 select * from data_dictionary.COLUMNS where table_name="t1"
 and column_name= "a";
-TABLE_SCHEMA	TABLE_NAME	COLUMN_NAME	COLUMN_TYPE	ORDINAL_POSITION	COLUMN_DEFAULT	COLUMN_DEFAULT_IS_NULL	COLUMN_DEFAULT_UPDATE	IS_NULLABLE	DATA_TYPE	CHARACTER_MAXIMUM_LENGTH	CHARACTER_OCTET_LENGTH	NUMERIC_PRECISION	NUMERIC_SCALE	COLLATION_NAME	COLUMN_COMMENT
-mysqltest	t1	a	INTEGER	0		TRUE		TRUE	INTEGER	0	0	0	0		
+TABLE_SCHEMA	TABLE_NAME	COLUMN_NAME	COLUMN_TYPE	ORDINAL_POSITION	COLUMN_DEFAULT	COLUMN_DEFAULT_IS_NULL	COLUMN_DEFAULT_UPDATE	IS_NULLABLE	IS_INDEXED	IS_USED_IN_PRIMARY	IS_UNIQUE	IS_MULTI	IS_FIRST_IN_MULTI	INDEXES_FOUND_IN	DATA_TYPE	CHARACTER_MAXIMUM_LENGTH	CHARACTER_OCTET_LENGTH	NUMERIC_PRECISION	NUMERIC_SCALE	COLLATION_NAME	COLUMN_COMMENT
+mysqltest	t1	a	INTEGER	0		TRUE		TRUE	FALSE	FALSE	FALSE	FALSE	FALSE	0	INTEGER	0	0	0	0		
 select table_name, column_name from data_dictionary.columns 
 where table_schema = 'mysqltest' and table_name = 't1';
 table_name	column_name
@@ -174,7 +174,7 @@
 Field	Type	Null	Default	Default_is_NULL	On_Update
 f1	INTEGER	TRUE		TRUE	
 describe t1;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 f1	INTEGER	TRUE		TRUE	
 show indexes from t1;
 Table	Unique	Key_name	Seq_in_index	Column_name
@@ -194,7 +194,7 @@
  or DATA_TYPE = 'varchar')
 group by DATA_TYPE order by DATA_TYPE, num;
 DATA_TYPE	group_concat(table_schema, '.', table_name)	num
-VARCHAR	data_dictionary.CHARACTER_SETS,data_dictionary.CHARACTER_SETS,data_dictionary.CHARACTER_SETS,data_dictionary.COLLATIONS,data_dictionary.COLLATIONS,data_dictionary.COLLATIONS,data_dictionary.COLLATIONS,data_dictionary.COLLATIONS,data_dictionary.COLUMNS,data_dictionary.COLUMNS,data_dictionary.COLUMNS,data_dictionary.COLUMNS,data_dictionary.COLUMNS,data_dictionary.COLUMNS,data_dictionary.COLUMNS,data_dictionary.COLUMNS,data_dictionary.COLUMNS,data_dictionary.COLUMNS,data_dictionary.COLUMNS,data_dictionary.GLOBAL_STATEMENTS,data_dictionary.GLOBAL_STATEMENTS,data_dictionary.GLOBAL_STATUS,data_dictionary.GLOBAL_STATUS,data_dictionary.GLOBAL_VARIABLES,data_dictionary.GLOBAL_VARIABLES,data_dictionary.INDEXES,data_dictionary.INDEXES,data_dictionary.INDEXES,data_dictionary.INDEXES,data_dictionary.INDEXES,data_dictionary.INDEXES,data_dictionary.INDEXES,data_dictionary.INDEXES,data_dictionary.INDEX_PARTS,data_dictionary.INDEX_PARTS,data_dictionary.INDEX_PARTS,data_dictionary.INDEX_PARTS,data_dictionary.INDEX_PARTS,data_d	131
+VARCHAR	data_dictionary.CHARACTER_SETS,data_dictionary.CHARACTER_SETS,data_dictionary.CHARACTER_SETS,data_dictionary.COLLATIONS,data_dictionary.COLLATIONS,data_dictionary.COLLATIONS,data_dictionary.COLLATIONS,data_dictionary.COLLATIONS,data_dictionary.COLUMNS,data_dictionary.COLUMNS,data_dictionary.COLUMNS,data_dictionary.COLUMNS,data_dictionary.COLUMNS,data_dictionary.COLUMNS,data_dictionary.COLUMNS,data_dictionary.COLUMNS,data_dictionary.COLUMNS,data_dictionary.COLUMNS,data_dictionary.COLUMNS,data_dictionary.COLUMNS,data_dictionary.COLUMNS,data_dictionary.COLUMNS,data_dictionary.COLUMNS,data_dictionary.COLUMNS,data_dictionary.GLOBAL_STATEMENTS,data_dictionary.GLOBAL_STATEMENTS,data_dictionary.GLOBAL_STATUS,data_dictionary.GLOBAL_STATUS,data_dictionary.GLOBAL_VARIABLES,data_dictionary.GLOBAL_VARIABLES,data_dictionary.INDEXES,data_dictionary.INDEXES,data_dictionary.INDEXES,data_dictionary.INDEXES,data_dictionary.INDEXES,data_dictionary.INDEXES,data_dictionary.INDEXES,data_dictionary.INDEXES,data_dictionary.INDEX_PART	139
 Warnings:
 Warning	1260	1 line(s) were cut by GROUP_CONCAT()
 create table t1(f1 char(1) not null, f2 char(9) not null);
@@ -334,13 +334,13 @@
 WHERE TABLE_SCHEMA='mysql' and TABLE_NAME= 'db';
 TABLE_COLLATION
 select * from data_dictionary.columns where table_schema = NULL;
-TABLE_SCHEMA	TABLE_NAME	COLUMN_NAME	COLUMN_TYPE	ORDINAL_POSITION	COLUMN_DEFAULT	COLUMN_DEFAULT_IS_NULL	COLUMN_DEFAULT_UPDATE	IS_NULLABLE	DATA_TYPE	CHARACTER_MAXIMUM_LENGTH	CHARACTER_OCTET_LENGTH	NUMERIC_PRECISION	NUMERIC_SCALE	COLLATION_NAME	COLUMN_COMMENT
+TABLE_SCHEMA	TABLE_NAME	COLUMN_NAME	COLUMN_TYPE	ORDINAL_POSITION	COLUMN_DEFAULT	COLUMN_DEFAULT_IS_NULL	COLUMN_DEFAULT_UPDATE	IS_NULLABLE	IS_INDEXED	IS_USED_IN_PRIMARY	IS_UNIQUE	IS_MULTI	IS_FIRST_IN_MULTI	INDEXES_FOUND_IN	DATA_TYPE	CHARACTER_MAXIMUM_LENGTH	CHARACTER_OCTET_LENGTH	NUMERIC_PRECISION	NUMERIC_SCALE	COLLATION_NAME	COLUMN_COMMENT
 select * from `data_dictionary`.`COLUMNS` where `TABLE_NAME` = NULL;
-TABLE_SCHEMA	TABLE_NAME	COLUMN_NAME	COLUMN_TYPE	ORDINAL_POSITION	COLUMN_DEFAULT	COLUMN_DEFAULT_IS_NULL	COLUMN_DEFAULT_UPDATE	IS_NULLABLE	DATA_TYPE	CHARACTER_MAXIMUM_LENGTH	CHARACTER_OCTET_LENGTH	NUMERIC_PRECISION	NUMERIC_SCALE	COLLATION_NAME	COLUMN_COMMENT
+TABLE_SCHEMA	TABLE_NAME	COLUMN_NAME	COLUMN_TYPE	ORDINAL_POSITION	COLUMN_DEFAULT	COLUMN_DEFAULT_IS_NULL	COLUMN_DEFAULT_UPDATE	IS_NULLABLE	IS_INDEXED	IS_USED_IN_PRIMARY	IS_UNIQUE	IS_MULTI	IS_FIRST_IN_MULTI	INDEXES_FOUND_IN	DATA_TYPE	CHARACTER_MAXIMUM_LENGTH	CHARACTER_OCTET_LENGTH	NUMERIC_PRECISION	NUMERIC_SCALE	COLLATION_NAME	COLUMN_COMMENT
 select * from `data_dictionary`.`INDEXES` where `TABLE_SCHEMA` = NULL;
-TABLE_SCHEMA	TABLE_NAME	INDEX_NAME	IS_PRIMARY	IS_UNIQUE	IS_NULLABLE	KEY_LENGTH	INDEX_TYPE	INDEX_COMMENT
+TABLE_SCHEMA	TABLE_NAME	INDEX_NAME	IS_USED_IN_PRIMARY	IS_UNIQUE	IS_NULLABLE	KEY_LENGTH	INDEX_TYPE	INDEX_COMMENT
 select * from `data_dictionary`.`INDEXES` where `TABLE_NAME` = NULL;
-TABLE_SCHEMA	TABLE_NAME	INDEX_NAME	IS_PRIMARY	IS_UNIQUE	IS_NULLABLE	KEY_LENGTH	INDEX_TYPE	INDEX_COMMENT
+TABLE_SCHEMA	TABLE_NAME	INDEX_NAME	IS_USED_IN_PRIMARY	IS_UNIQUE	IS_NULLABLE	KEY_LENGTH	INDEX_TYPE	INDEX_COMMENT
 select * from data_dictionary.schemas where schema_name = NULL;
 SCHEMA_NAME	DEFAULT_COLLATION_NAME
 select * from data_dictionary.tables where table_schema = NULL;

=== modified file 'tests/r/func_sapdb.result'
--- tests/r/func_sapdb.result	2010-02-19 19:04:24 +0000
+++ tests/r/func_sapdb.result	2010-03-02 16:42:01 +0000
@@ -109,7 +109,7 @@
 select makedate(1997,1) as f1,
 date("1997-12-31 23:59:59.000001") as f8;
 describe t1;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 f1	DATE	TRUE		TRUE	
 f8	DATE	TRUE		TRUE	
 select * from t1;

=== modified file 'tests/r/func_time.result'
--- tests/r/func_time.result	2010-02-19 19:04:24 +0000
+++ tests/r/func_time.result	2010-03-02 16:42:01 +0000
@@ -634,7 +634,7 @@
 create table t1 select last_day('2000-02-05') as a,
 from_days(to_days("960101")) as b;
 describe t1;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 a	DATE	FALSE		FALSE	
 b	DATE	TRUE		TRUE	
 select * from t1;

=== modified file 'tests/r/information_schema.result'
Binary files tests/r/information_schema.result and tests/r/information_schema.result differ
=== modified file 'tests/r/information_schema_inno.result'
Binary files tests/r/information_schema_inno.result and tests/r/information_schema_inno.result differ
=== modified file 'tests/r/innodb.result'
--- tests/r/innodb.result	2010-03-01 22:24:10 +0000
+++ tests/r/innodb.result	2010-03-02 16:42:01 +0000
@@ -883,7 +883,7 @@
 drop table t1;
 create table t1 (t int not null default 1, key (t)) engine=innodb;
 desc t1;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 t	INTEGER	FALSE	1	FALSE	
 drop table t1;
 create table t1 (id int not null auto_increment, code int not null, name char(20) not null, primary key (id), key (code), unique (name)) engine=innodb;

=== modified file 'tests/r/innodb_mysql.result'
--- tests/r/innodb_mysql.result	2010-02-19 19:04:24 +0000
+++ tests/r/innodb_mysql.result	2010-03-02 16:42:01 +0000
@@ -1153,7 +1153,7 @@
 create table t1(a char(10) not null, unique key aa(a(1)),
 b char(4) not null, unique key bb(b(4))) engine=innodb;
 desc t1;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 a	VARCHAR	FALSE		FALSE	
 b	VARCHAR	FALSE		FALSE	
 show create table t1;

=== modified file 'tests/r/key.result'
--- tests/r/key.result	2010-03-01 22:24:10 +0000
+++ tests/r/key.result	2010-03-02 16:42:01 +0000
@@ -301,7 +301,7 @@
 UNIQUE i1idx (i1),
 UNIQUE i2idx (i2));
 desc t1;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 i1	INTEGER	FALSE		FALSE	
 i2	INTEGER	FALSE		FALSE	
 show create table t1;
@@ -357,25 +357,25 @@
 drop table t1;
 create table t1 (a int not null primary key, b varchar(20) not null unique);
 desc t1;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 a	INTEGER	FALSE		FALSE	
 b	VARCHAR	FALSE		FALSE	
 drop table t1;
 create table t1 (a int not null primary key, b int not null unique);
 desc t1;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 a	INTEGER	FALSE		FALSE	
 b	INTEGER	FALSE		FALSE	
 drop table t1;
 create table t1 (a int not null primary key, b varchar(20) not null, unique (b(10)));
 desc t1;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 a	INTEGER	FALSE		FALSE	
 b	VARCHAR	FALSE		FALSE	
 drop table t1;
 create table t1 (a int not null primary key, b varchar(20) not null, c varchar(20) not null, unique(b(10),c(10)));
 desc t1;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 a	INTEGER	FALSE		FALSE	
 b	VARCHAR	FALSE		FALSE	
 c	VARCHAR	FALSE		FALSE	
@@ -493,7 +493,7 @@
 b char(10) not null, unique key bb(b(1)), 
 c char(4) not null, unique key cc(c));
 desc t1;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 a	INTEGER	FALSE		FALSE	
 b	VARCHAR	FALSE		FALSE	
 c	VARCHAR	FALSE		FALSE	
@@ -512,13 +512,13 @@
 b char(10) not null, unique key bb(b(1)),
 c char(4) not null);
 desc t1;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 a	INTEGER	FALSE		FALSE	
 b	VARCHAR	FALSE		FALSE	
 c	VARCHAR	FALSE		FALSE	
 alter table t1 add unique key cc(c);
 desc t1;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 a	INTEGER	FALSE		FALSE	
 b	VARCHAR	FALSE		FALSE	
 c	VARCHAR	FALSE		FALSE	

=== modified file 'tests/r/mysql.result'
--- tests/r/mysql.result	2010-02-19 19:04:24 +0000
+++ tests/r/mysql.result	2010-03-02 16:42:01 +0000
@@ -39,7 +39,7 @@
 +------+------+---------------------------+
 i	j	k
 NULL	1	NULL
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 i	INTEGER	TRUE		TRUE	
 j	INTEGER	FALSE		FALSE	
 k	INTEGER	TRUE		TRUE	
@@ -49,7 +49,7 @@
 | NULL | 1 | NULL | 
 +------+---+------+
 +-------+---------+-------+---------+-----------------+-----------+
-| Field | Type    | Null  | Default | Default is NULL | On Update |
+| Field | Type    | Null  | Default | Default_is_NULL | On_Update |
 +-------+---------+-------+---------+-----------------+-----------+
 | i     | INTEGER | TRUE  |         | TRUE            |           | 
 | j     | INTEGER | FALSE |         | FALSE           |           | 
@@ -74,11 +74,11 @@
 | NULL        | 
 +-------------+
 create table t1(a int, b varchar(255), c int);
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 a	INTEGER	TRUE		TRUE	
 b	VARCHAR	TRUE		TRUE	
 c	INTEGER	TRUE		TRUE	
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 a	INTEGER	TRUE		TRUE	
 b	VARCHAR	TRUE		TRUE	
 c	INTEGER	TRUE		TRUE	

=== modified file 'tests/r/null.result'
--- tests/r/null.result	2010-02-19 19:04:24 +0000
+++ tests/r/null.result	2010-03-02 16:42:01 +0000
@@ -240,17 +240,17 @@
 INSERT INTO t1 (a, b) VALUES (0, 0);
 CREATE TABLE t2 SELECT IFNULL(a, b) FROM t1;
 DESCRIBE t2;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 IFNULL(a, b)	DECIMAL	TRUE		TRUE	
 DROP TABLE t2;
 CREATE TABLE t2 SELECT IFNULL(a, NULL) FROM t1;
 DESCRIBE t2;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 IFNULL(a, NULL)	DECIMAL	TRUE		TRUE	
 DROP TABLE t2;
 CREATE TABLE t2 SELECT IFNULL(NULL, b) FROM t1;
 DESCRIBE t2;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 IFNULL(NULL, b)	DECIMAL	TRUE		TRUE	
 DROP TABLE t1, t2;
 # End of 5.0 tests

=== modified file 'tests/r/parser.result'
--- tests/r/parser.result	2010-02-19 19:04:24 +0000
+++ tests/r/parser.result	2010-03-02 16:42:01 +0000
@@ -241,7 +241,7 @@
 CREATE TABLE table_25930_a ( blah INT );
 CREATE TABLE table_25930_b SELECT "blah" - 1 FROM table_25930_a;
 desc table_25930_b;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 "blah" - 1	DOUBLE	FALSE		FALSE	
 DROP TABLE table_25930_a;
 DROP TABLE table_25930_b;

=== added file 'tests/r/randgen_queries.result'
--- tests/r/randgen_queries.result	1970-01-01 00:00:00 +0000
+++ tests/r/randgen_queries.result	2010-03-02 17:58:59 +0000
@@ -0,0 +1,110 @@
+drop table if exists t1;
+show variables like 'version';
+Variable_name	Value
+version	####.##.####
+select version();
+version()
+####.##.####
+select database();
+database()
+test
+CREATE TABLE `t1` (
+`col_bigint` bigint,
+`col_text` text,
+`col_char` char (1),
+`col_enum` enum ('a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z'),
+`col_int` int,
+`col_char_not_null` char (1) not null,
+`col_int_not_null_key` int not null,
+`col_text_not_null` text not null,
+`col_enum_not_null_key` enum ('a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z') not null,
+`col_int_key` int,
+`col_char_key` char (1),
+`col_enum_not_null` enum ('a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z') not null,
+`col_text_not_null_key` text not null,
+pk integer auto_increment,
+`col_bigint_key` bigint,
+`col_int_not_null` int not null,
+`col_bigint_not_null` bigint not null,
+`col_bigint_not_null_key` bigint not null,
+`col_char_not_null_key` char (1) not null,
+`col_text_key` text,
+`col_enum_key` enum ('a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z'),
+/*Indices*/
+key (`col_int_not_null_key` ),
+key (`col_enum_not_null_key` ),
+key (`col_int_key` ),
+key (`col_char_key` ),
+key (`col_text_not_null_key`  (255)),
+primary key (pk),
+key (`col_bigint_key` ),
+key (`col_bigint_not_null_key` ),
+key (`col_char_not_null_key` ),
+key (`col_text_key`  (255)),
+key (`col_enum_key` )) ENGINE=innodb;
+Warnings:
+Warning	1071	Specified key was too long; max key length is 767 bytes
+Warning	1071	Specified key was too long; max key length is 767 bytes
+set AUTOCOMMIT=OFF;
+select table_schema, 
+table_name, 
+'STANDARD',
+#       CASE WHEN table_type = 'STANDARD' THEN 'table' 
+#            WHEN table_type = 'VIEW' THEN 'view' 
+#            WHEN table_type = 'FUNCTION' then 'view' 
+#       ELSE 'misc' END, 
+column_name,
+CASE WHEN IS_USED_IN_PRIMARY = 'TRUE' THEN 'primary' 
+#      WHEN column_key = 'MUL' THEN 'indexed' 
+#      WHEN column_key = 'UNI' THEN 'indexed' 
+ELSE 'indexed' END 
+FROM data_dictionary.index_parts;
+table_schema	table_name	STANDARD	column_name	CASE WHEN IS_USED_IN_PRIMARY = 'TRUE' THEN 'primary' 
+#      WHEN column_key = 'MUL' THEN 'indexed' 
+#      WHEN column_key = 'UNI' THEN 'indexed' 
+ELSE 'indexed' END 
+
+test	t1	STANDARD	pk	primary
+test	t1	STANDARD	col_int_not_null_key	indexed
+test	t1	STANDARD	col_enum_not_null_key	indexed
+test	t1	STANDARD	col_int_key	indexed
+test	t1	STANDARD	col_char_key	indexed
+test	t1	STANDARD	col_text_not_null_key	indexed
+test	t1	STANDARD	col_bigint_key	indexed
+test	t1	STANDARD	col_bigint_not_null_key	indexed
+test	t1	STANDARD	col_char_not_null_key	indexed
+test	t1	STANDARD	col_text_key	indexed
+test	t1	STANDARD	col_enum_key	indexed
+select AVG(`col_int_key`) + AVG(`col_int`) AS average1,
+(SUM(`col_int_key`) + SUM(`col_int`)) / COUNT(*) AS average2,
+COUNT(*) AS count FROM t1;
+average1	average2	count
+NULL	NULL	0
+select collation_name,character_set_name FROM data_dictionary.collations;
+collation_name	character_set_name
+utf8_general_ci	utf8_general_ci
+utf8_bin	utf8_general_ci
+utf8_unicode_ci	utf8_general_ci
+utf8_icelandic_ci	utf8_general_ci
+utf8_latvian_ci	utf8_general_ci
+utf8_romanian_ci	utf8_general_ci
+utf8_slovenian_ci	utf8_general_ci
+utf8_polish_ci	utf8_general_ci
+utf8_estonian_ci	utf8_general_ci
+utf8_spanish_ci	utf8_general_ci
+utf8_swedish_ci	utf8_general_ci
+utf8_turkish_ci	utf8_general_ci
+utf8_czech_ci	utf8_general_ci
+utf8_danish_ci	utf8_general_ci
+utf8_lithuanian_ci	utf8_general_ci
+utf8_slovak_ci	utf8_general_ci
+utf8_spanish2_ci	utf8_general_ci
+utf8_roman_ci	utf8_general_ci
+utf8_persian_ci	utf8_general_ci
+utf8_esperanto_ci	utf8_general_ci
+utf8_hungarian_ci	utf8_general_ci
+utf8_sinhala_ci	utf8_general_ci
+binary	binary
+select COUNT(*) from data_dictionary.tables;
+COUNT(*)
+32

=== modified file 'tests/r/type_datetime.result'
--- tests/r/type_datetime.result	2010-02-19 19:04:24 +0000
+++ tests/r/type_datetime.result	2010-03-02 16:42:01 +0000
@@ -341,57 +341,57 @@
 create table t1 (f1 date, f2 datetime, f3 varchar(20));
 create table t2 as select coalesce(f1,f1) as f4 from t1;
 desc t2;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 f4	DATE	TRUE		TRUE	
 create table t3 as select coalesce(f1,f2) as f4 from t1;
 desc t3;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 f4	DATETIME	TRUE		TRUE	
 create table t4 as select coalesce(f2,f2) as f4 from t1;
 desc t4;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 f4	DATETIME	TRUE		TRUE	
 create table t5 as select coalesce(f1,f3) as f4 from t1;
 desc t5;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 f4	VARCHAR	TRUE		TRUE	
 create table t6 as select coalesce(f2,f3) as f4 from t1;
 desc t6;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 f4	VARCHAR	TRUE		TRUE	
 create table t7 as select coalesce(makedate(1997,1),f2) as f4 from t1;
 desc t7;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 f4	DATETIME	TRUE		TRUE	
 create table t8 as select coalesce(cast('01-01-01' as datetime),f2) as f4
 from t1;
 desc t8;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 f4	DATETIME	TRUE		TRUE	
 create table t9 as select case when 1 then cast('01-01-01' as date)
 when 0 then cast('01-01-01' as date) end as f4 from t1;
 desc t9;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 f4	DATE	TRUE		TRUE	
 create table t10 as select case when 1 then cast('01-01-01' as datetime)
 when 0 then cast('01-01-01' as datetime) end as f4 from t1;
 desc t10;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 f4	DATETIME	TRUE		TRUE	
 create table t11 as select if(1, cast('01-01-01' as datetime),
 cast('01-01-01' as date)) as f4 from t1;
 desc t11;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 f4	DATE	TRUE		TRUE	
 create table t12 as select least(cast('01-01-01' as datetime),
 cast('01-01-01' as date)) as f4 from t1;
 desc t12;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 f4	DATE	TRUE		TRUE	
 create table t13 as select ifnull(cast('01-01-01' as datetime),
 cast('01-01-01' as date)) as f4 from t1;
 desc t13;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 f4	DATE	TRUE		TRUE	
 drop tables t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13;
 ###################################################################

=== modified file 'tests/r/type_float.result'
--- tests/r/type_float.result	2010-03-02 01:04:20 +0000
+++ tests/r/type_float.result	2010-03-02 16:42:01 +0000
@@ -208,22 +208,22 @@
 show warnings;
 Level	Code	Message
 desc  t1;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 x	DECIMAL	FALSE		FALSE	
 drop table t1;
 create table t1 select 0.0 x;
 desc t1;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 x	DECIMAL	FALSE		FALSE	
 create table t2 select 105213674794682365.00 y;
 desc t2;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 y	DECIMAL	FALSE		FALSE	
 create table t3 select x+y a from t1,t2;
 show warnings;
 Level	Code	Message
 desc t3;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 a	DECIMAL	FALSE		FALSE	
 drop table t1,t2,t3;
 select 1e-308, 1.00000001e-300, 100000000e-300;

=== modified file 'tests/r/union.result'
--- tests/r/union.result	2010-03-02 01:04:20 +0000
+++ tests/r/union.result	2010-03-02 16:42:01 +0000
@@ -1438,24 +1438,24 @@
 INSERT INTO t1 VALUES (1), (2), (3);
 CREATE TABLE t2 SELECT * FROM (SELECT NULL) a UNION SELECT a FROM t1;
 DESC t2;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 NULL	INTEGER	TRUE		TRUE	
 CREATE TABLE t3 SELECT a FROM t1 UNION SELECT * FROM (SELECT NULL) a;
 DESC t3;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 a	INTEGER	TRUE		TRUE	
 CREATE TABLE t4 SELECT NULL;
 DESC t4;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 NULL	VARCHAR	TRUE		TRUE	
 CREATE TABLE t5 SELECT NULL UNION SELECT NULL;
 DESC t5;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 NULL	VARCHAR	TRUE		TRUE	
 CREATE TABLE t6 
 SELECT * FROM (SELECT * FROM (SELECT NULL)a) b UNION SELECT a FROM t1;
 DESC t6;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 NULL	INTEGER	TRUE		TRUE	
 DROP TABLE t1, t2, t3, t4, t5, t6;
 End of 5.0 tests

=== added file 'tests/t/randgen_queries.test'
--- tests/t/randgen_queries.test	1970-01-01 00:00:00 +0000
+++ tests/t/randgen_queries.test	2010-03-02 17:58:59 +0000
@@ -0,0 +1,69 @@
+--disable_warnings
+drop table if exists t1;
+--enable_warnings
+
+# execute all the queries that randgen uses to setup and run its tests
+--replace_column 2 ####.##.####
+show variables like 'version';
+--replace_column 1 ####.##.####
+select version();
+select database();
+
+CREATE TABLE `t1` (
+`col_bigint` bigint,
+`col_text` text,
+`col_char` char (1),
+`col_enum` enum ('a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z'),
+`col_int` int,
+`col_char_not_null` char (1) not null,
+`col_int_not_null_key` int not null,
+`col_text_not_null` text not null,
+`col_enum_not_null_key` enum ('a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z') not null,
+`col_int_key` int,
+`col_char_key` char (1),
+`col_enum_not_null` enum ('a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z') not null,
+`col_text_not_null_key` text not null,
+pk integer auto_increment,
+`col_bigint_key` bigint,
+`col_int_not_null` int not null,
+`col_bigint_not_null` bigint not null,
+`col_bigint_not_null_key` bigint not null,
+`col_char_not_null_key` char (1) not null,
+`col_text_key` text,
+`col_enum_key` enum ('a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z'),
+/*Indices*/
+key (`col_int_not_null_key` ),
+key (`col_enum_not_null_key` ),
+key (`col_int_key` ),
+key (`col_char_key` ),
+key (`col_text_not_null_key`  (255)),
+primary key (pk),
+key (`col_bigint_key` ),
+key (`col_bigint_not_null_key` ),
+key (`col_char_not_null_key` ),
+key (`col_text_key`  (255)),
+key (`col_enum_key` )) ENGINE=innodb;
+set AUTOCOMMIT=OFF;
+
+# Obviously, FUNCTION does not always means VIEW.
+#
+select table_schema, 
+       table_name, 
+       'STANDARD',
+#       CASE WHEN table_type = 'STANDARD' THEN 'table' 
+#            WHEN table_type = 'VIEW' THEN 'view' 
+#            WHEN table_type = 'FUNCTION' then 'view' 
+#       ELSE 'misc' END, 
+       column_name,
+       CASE WHEN IS_USED_IN_PRIMARY = 'TRUE' THEN 'primary' 
+      #      WHEN column_key = 'MUL' THEN 'indexed' 
+      #      WHEN column_key = 'UNI' THEN 'indexed' 
+       ELSE 'indexed' END 
+FROM data_dictionary.index_parts;
+
+select AVG(`col_int_key`) + AVG(`col_int`) AS average1,
+                        (SUM(`col_int_key`) + SUM(`col_int`)) / COUNT(*) AS average2,
+                        COUNT(*) AS count FROM t1;
+
+select collation_name,character_set_name FROM data_dictionary.collations;
+select COUNT(*) from data_dictionary.tables;

